Ddoc

$(D_S Compiler for D Programming Language,

	$(UL 
	<li> D for <a href="#Win32">Win32</a>
	<li> D for <a href="#linux">x86 Linux</a>
	<li> <a href="#general">general</a>
	)

<h2>Downloads</h2>

	$(UL
	$(LI Download
	 <a href="http://ftp.digitalmars.com/dmd.zip" title="download D compiler">
	 dmd.zip (D compiler)</a> for Win32 and Linux

	$(UL
	$(LI Mirror: $(LINK2 http://mrradar.dreamhosters.com/public/dmd/, dreamhosters))
	$(LI Mirror: $(LINK2 http://s3.amazonaws.com/puremagic/dmd.1.00.zip?torrent, puremagic (torrent)))
	$(LI Mirror: $(LINK2 http://s3.amazonaws.com/puremagic/dmd.1.00.zip, puremagic (http)))
	$(LI Mirror: $(LINK2 ftp://63.99.9.206/dmd.1.00.zip, 63.99.9.206))
	)

	)

	$(LI Download
	 <a href="http://ftp.digitalmars.com/dmc.zip" title="download dmc.zip">
	 dmc.zip (linker and utilities)</a> for Win32
	)
	)

<h2>Files Common to Win32 and Linux</h2>

	<dl>

	<dt>$(TT \dmd\src\phobos\)
	<dd>D runtime library source

	<dt>$(TT \dmd\src\dmd\)
	<dd>D compiler front end source under dual (GPL and Artistic) license

	<dt>$(TT \dmd\html\d\)
	<dd>Documentation

	<dt>$(TT \dmd\samples\d\)
	<dd>Sample D programs

	</dl>

<hr>
<h1><a name="Win32">Win32 D Compiler</a></h1>

<h2>Requirements and Downloads</h2>

	$(UL 
	<li> 32 bit Windows (Win32) operating system, such as Windows XP

	$(LI Download
	 <a href="http://ftp.digitalmars.com/dmd.zip" title="download D compiler">
	 dmd.zip (D compiler)</a> for Win32

	$(UL
	$(LI Mirror: $(LINK2 http://mrradar.dreamhosters.com/public/dmd/, dreamhosters))
	$(LI Mirror: $(LINK2 http://s3.amazonaws.com/puremagic/dmd.1.00.zip?torrent, puremagic (torrent)))
	$(LI Mirror: $(LINK2 http://s3.amazonaws.com/puremagic/dmd.1.00.zip, puremagic (http)))
	$(LI Mirror: $(LINK2 ftp://63.99.9.206/dmd.1.00.zip, 63.99.9.206))
	)

	)

	$(LI Download
	 <a href="http://ftp.digitalmars.com/dmc.zip" title="download dmc.zip">
	 dmc.zip (linker and utilities)</a> for Win32
	)

	)

<h2>Files</h2>

	<dl>

	<dt>$(TT \dmd\bin\dmd.exe)
	<dd>D compiler executable

	<dt>$(TT \dmd\bin\shell.exe)
	<dd>Simple command line shell

	<dt>$(TT \dmd\bin\sc.ini)
	<dd>Global compiler settings

	<dt>$(TT \dmd\lib\phobos.lib)
	<dd>D runtime library

	</dl>

<h2>Installation</h2>

	Open a console window (for Windows XP this is done by
	clicking on [Start][Command Prompt]).
	All the tools are command line tools, which means
	they are run from a console window.
	Switch to the root directory.
	Unzip the files in the root directory.
	$(TT dmd.zip) will create
	a $(TT \dmd) directory with all the files in it.
	$(TT dmc.zip) will create
	a $(TT \dm) directory with all the files in it.
	<p>

	A typical session might look like:

$(CONSOLE
C:\Documents and Settings\Your Name&gt;cd \ 
C:\&gt;unzip dmd.zip
C:\&gt;unzip dmc.zip
)

<h2>Example</h2>

	Run:

$(CONSOLE
\dmd\bin\shell all.sh
)

	in the $(TT \dmd\samples\d) directory for several small examples.

<h2>Compiler Arguments and Switches</h2>

	<dl><dl>
	  <dt>$(B dmd) $(I files)... -$(I switches)...
	  <p>
	  <dt>$(I files)...
		<dd>
		<table border=1 cellpadding=4 cellspacing=0 summary="File Extensions">
		<tr>
		<th>Extension
		<th>File Type
		<tr>
		<td>$(I none)
		<td>D source files
		<tr>
		<td>$(B .d)
		<td>D source files
		<tr>
		<td>$(B .di)
		<td>$(LINK2 #interface_files, D interface files)
		<tr>
		<td>$(B .obj)
		<td>Object files to link in
		<tr>
		<td>$(B .lib)
		<td>Object code libraries to search
		<tr>
		<td>$(B .exe)
		<td>Name output executable file
		<tr>
		<td>$(B .def)
		<td>module definition file
		<tr>
		<td>$(B .res)
		<td>resource file
		</table>

	  $(DT $(B @)$(I cmdfile))
		$(DD reads compiler arguments and switches from
		text file $(I cmdfile))

	  <dt>$(B -c)</dt>
		<dd>compile only, do not link</dd>

	  <dt>$(B -cov)</dt>
		<dd>instrument for $(LINK2 code_coverage.html, code coverage analysis)</dd>

	  $(DT $(B -D))
		$(DD Generate $(LINK2 ddoc.html, documentation) from source.)

	  <dt>$(B -Dd)$(I docdir)</dt>
		<dd>write documentation file to $(I docdir) directory</dd>

	  <dt>$(B -Df)$(I filename)</dt>
		<dd>write documentation file to $(I filename)</dd>

	  <dt>$(B -d)</dt>
		<dd>allow deprecated features
	  <dt>$(B -debug)</dt>
		<dd>compile in debug code
	  <dt>$(B -debug=)$(I level)</dt>
		<dd>compile in debug code <= $(I level)
	  <dt>$(B -debug=)$(I ident)</dt>
		<dd>compile in debug code identified by $(I ident)
	  <dt>$(B -g)</dt>
		<dd>add symbolic debug info

	  $(DT $(B -H))
		$(DD generate D interface file)

	  $(DT $(B -Hd)$(I dir))
		$(DD write D interface file to $(I dir) directory)

	  $(DT $(B -Hf)$(I filename))
		$(DD write D interface file to $(I filename))

	  <dt>$(B --help)</dt>
		<dd>print help
	  <dt>$(B -inline)
		<dd>inline expand functions
	  <dt>$(B -I)$(I path)
		<dd>where to look for imports. $(I path) is a ; separated
		list of paths. Multiple $(B -I)'s can be used, and the paths
		are searched in the same order.
	  <dt>$(B -L)$(I linkerflag)
		<dd>pass $(I linkerflag) to the linker, for example,
		$(TT /ma/li)

	  $(DT $(B -nofloat))
		$(DD Prevents emission of $(B __fltused) reference in
		object files, even if floating point code is present.
		Useful for library code. Windows only.)

	  $(DT $(B -O))
		$(DD Optimize generated code.)

	  $(DT $(B -o-))
		$(DD Suppress generation of object file. Useful in
		conjuction with $(B -D) or $(B -H) flags.)

	  <dt>$(B -od)$(I objdir)</dt>
		<dd>write object files relative to directory $(I objdir)
		instead of to the current directory
	  <dt>$(B -of)$(I filename)</dt>
		<dd>set output file name to $(I filename) in the output
		directory
	  <dt>$(B -op)</dt>
		<dd>normally the path for $(B .d) source files is stripped
		off when generating an object file name. $(B -op) will leave
		it on.
	  <dt>$(B -profile)</dt>
		<dd><a href="http://www.digitalmars.com/ctg/trace.html">profile</a>
		the runtime performance
		of the generated code
	  <dt>$(B -quiet)</dt>
		<dd>suppress non-essential compiler messages
	  <dt>$(B -release)</dt>
		<dd>compile release version, which means not generating
		code for contracts and asserts
	  $(DT $(B -run) $(I srcfile args...))
		$(DD compile, link, and run the program $(I srcfile) with the
		rest of the
		command line, $(I args...), as the arguments to the program.
		No .obj or .exe file is left behind.)
	  <dt>$(B -unittest)</dt>
		<dd>compile in unittest code, also turns on asserts
	  <dt>$(B -v)</dt>
		<dd>verbose
	  <dt>$(B -version=)$(I level)</dt>
		<dd>compile in version code >= $(I level)
	  <dt>$(B -version=)$(I ident)</dt>
		<dd>compile in version code identified by $(I ident)
	  <dt>$(B -w)</dt>
		<dd>enable <a href="warnings.html">warnings</a>
	</dl></dl>

<h2>Linking</h2>

	Linking is done directly by the $(B dmd) compiler after a successful
	compile. To prevent $(B dmd) from running the linker, use the
	$(B -c) switch.
	<p>

	The programs must be linked with the D runtime library $(B phobos.lib),
	followed by the C runtime library $(B snn.lib).
	This is done automatically as long as the directories for the
	libraries are on the LIB environment variable path. A typical
	way to set LIB would be:

$(CONSOLE
set LIB=\dmd\lib;\dm\lib
)

<h2>Environment Variables</h2>

	The D compiler dmd uses the following environment variables:

	<dl>

	<dt>$(B DFLAGS)
	<dd>The value of $(B DFLAGS) is treated as if it were appended to the
	command line to $(B dmd.exe).

	<dt>$(B LIB)
	<dd>The linker uses $(B LIB) to search for library files. For D, it will
	normally be set to:

$(CONSOLE
set LIB=\dmd\lib;\dm\lib
)

	<dt>$(B LINKCMD)
	<dd> $(B dmd) normally runs the linker by looking for $(B link.exe)
	along the $(B PATH). To use a specific linker instead, set the
	$(B LINKCMD) environment variable to it. For example:

$(CONSOLE
set LINKCMD=\dm\bin\link
)

	<dt>$(B PATH)
	<dd>If the linker is not found in the same directory as $(B dmd.exe)
	is in, the $(B PATH) is searched for it.
	$(B Note:) other linkers named
	$(B link.exe) will likely not work.
	Make sure the Digital Mars $(B link.exe)
	is found first in the $(B PATH) before other $(B link.exe)'s,
	or use $(B LINKCMD) to specifically identify which linker
	to use.

	</dl>

<h2><a name="sc_ini">sc.ini Initialization File</a></h2>

	$(B dmd) will look for the initialization file $(B sc.ini) in the
	following sequence of directories:

	$(OL
	$(LI current working directory)
	$(LI directory specified by the $(B HOME) environment variable)
	$(LI directory $(B dmd.exe) resides in)
	)

	If found, environment variable
	settings in the file will override any existing settings.
	This is handy to make $(B dmd) independent of programs with
	conflicting use of environment variables.
	<p>

	Environment variables follow the $(TT [Environment]) section
	heading, in $(I NAME)=$(I value) pairs.
	The $(I NAME)s are treated as upper case.
	Comments are lines that start with ;.
	For example:

$(SCINI
; sc.ini file for dmd
; Names enclosed by %% are searched for in the existing environment
; and inserted. The special name %@P% is replaced with the path
; to this file.
[Environment]
LIB="%@P%\..\lib";\dm\lib
DFLAGS="-I%@P%\..\src\phobos"
LINKCMD="%@P%\..\..\dm\bin"
DDOCFILE=mysettings.ddoc
)

<h2>Common Installation Problems</h2>

	$(UL 
	<li> Using Cygwin's $(B unzip) utility has been known to cause
	strange problems.
	<li> Running the compiler under Cygwin's command shell has
	been also known to cause problems. Try getting it to work
	under the regular Windows shell $(B cmd.exe) before trying Cygwin's.
	<li> Installing $(B dmd) and $(B dmc) into directory paths with spaces
	in them causes problems.
	)

<hr>
<h1><a name="linux">Linux D Compiler</a></h1>

<h2>Requirements and Downloads</h2>

	$(UL 
	$(LI 32 bit x86 Linux operating system)

	$(LI Download
	 <a href="http://ftp.digitalmars.com/dmd.zip" title="download D compiler">
	 dmd.zip (D compiler)</a> for Linux

	$(UL
	$(LI Mirror: $(LINK2 http://mrradar.dreamhosters.com/public/dmd/, dreamhosters))
	$(LI Mirror: $(LINK2 http://s3.amazonaws.com/puremagic/dmd.1.00.zip?torrent, puremagic (torrent)))
	$(LI Mirror: $(LINK2 http://s3.amazonaws.com/puremagic/dmd.1.00.zip, puremagic (http)))
	$(LI Mirror: $(LINK2 ftp://63.99.9.206/dmd.1.00.zip, 63.99.9.206))
	)

	)

	$(LI Gnu C compiler (gcc))

	)

<h2>Files</h2>

	<dl>

	<dt>$(TT /dmd/bin/dmd)
	<dd>D compiler executable

	<dt>$(TT /dmd/bin/dumpobj)
	<dd>Elf file dumper

	<dt>$(TT /dmd/bin/obj2asm)
	<dd>Elf file disassembler

	<dt>$(TT /dmd/bin/dmd.conf)
	<dd>Global compiler settings (copy to $(TT /etc/dmd.conf))

	<dt>$(TT /dmd/lib/libphobos.a)
	<dd>D runtime library (copy to $(TT /usr/lib/libphobos.a))

	</dl>

<h2>Installation</h2>

	$(OL 

	<li> Unzip the archive into your home directory.
	It will create
	a $(TT ~/dmd) directory with all the files in it.
	All the tools are command line tools, which means
	they are run from a console window.

	<li> Edit the file $(TT ~/dmd/bin/dmd.conf) to put the path in to
	where the phobos source files are.

	<li> Copy $(TT dmd.conf) to $(TT /etc):

$(CONSOLE
cp dmd/bin/dmd.conf /etc
)

	<li> Give execute permission to the following files:

$(CONSOLE
chmod u+x dmd/bin/dmd dmd/bin/obj2asm dmd/bin/dumpobj
)

	<li> Put $(TT dmd/bin) on your $(B PATH),
	or copy the linux executables
	to $(TT /usr/local/bin)

	<li> Copy the library to $(TT /usr/lib):

$(CONSOLE
cp dmd/lib/libphobos.a /usr/lib
)
	)

<h2>Compiler Arguments and Switches</h2>

	<dl><dl>
	  <dt>$(B dmd) $(I files)... -$(I switch)...
	  <p>
	  <dt>$(I files)...
		<dd>
		<table border=1 cellpadding=4 cellspacing=0 summary="File Extensions">
		<tr>
		<th>Extension
		<th>File Type
		<tr>
		<td>$(I none)
		<td>D source files
		<tr>
		<td>$(B .d)
		<td>D source files
		<tr>
		<td>$(B .di)
		<td>$(LINK2 #interface_files, D interface files)
		<tr>
		<td>$(B .o)
		<td>Object files to link in
		<tr>
		<td>$(B .a)
		<td>Library files to link in
		<tr>
		</table>

	  <dt>$(B -c)</dt>
		<dd>compile only, do not link</dd>

	  <dt>$(B -cov)</dt>
		<dd>instrument for $(LINK2 code_coverage.html, code coverage analysis)</dd>

	  <dt>$(B -D)</dt>
		<dd>generate documentation</dd>

	  <dt>$(B -Dd)$(I docdir)</dt>
		<dd>write documentation file to $(I docdir) directory</dd>

	  <dt>$(B -Df)$(I filename)</dt>
		<dd>write documentation file to $(I filename)</dd>

	  <dt>$(B -d)</dt>
		<dd>allow deprecated features
	  <dt>$(B -debug)</dt>
		<dd>compile in debug code
	  <dt>$(B -debug=)$(I level)</dt>
		<dd>compile in debug code <= $(I level)
	  <dt>$(B -debug=)$(I ident)</dt>
		<dd>compile in debug code identified by $(I ident)
	  <dt>$(B -fPIC)</dt>
		<dd>generate position independent code
	  <dt>$(B -g)</dt>
		<dd>add symbolic debug info
	  <dt>$(B -gc)</dt>
		<dd>add symbolic debug info in C format (for older gdb's)

	  $(DT $(B -H))
		$(DD generate D interface file)

	  $(DT $(B -Hd)$(I dir))
		$(DD write D interface file to $(I dir) directory)

	  $(DT $(B -Hf)$(I filename))
		$(DD write D interface file to $(I filename))

	  <dt>$(B --help)</dt>
		<dd>print help
	  <dt>$(B -inline)
		<dd>inline expand functions
	  <dt>$(B -I)$(I path)
		<dd>where to look for imports. $(I path) is a : separated
		list of paths. Multiple $(B -I)'s can be used, and the paths
		are searched in the same order.
	  <dt>$(B -L)$(I linkerflag)
		<dd>pass $(I linkerflag) to the linker, for example,
		$(TT -M)
	  <dt>$(B -O)</dt>
		<dd>optimize
	  <dt>$(B -o-)</dt>
		<dd>suppress generation of object file
	  <dt>$(B -od)$(I objdir)</dt>
		<dd>write object files relative to directory $(I objdir)
		instead of to the current directory
	  <dt>$(B -of)$(I filename)</dt>
		<dd>set output file name to $(I filename) in the output
		directory
	  <dt>$(B -op)</dt>
		<dd>normally the path for $(B .d) source files is stripped
		off when generating an object file name. $(B -op) will leave
		it on.
	  <dt>$(B -quiet)</dt>
		<dd>suppress non-essential compiler messages
	  <dt>$(B -profile)</dt>
		<dd><a href="http://www.digitalmars.com/ctg/trace.html">profile</a>
		the runtime performance
		of the generated code
	  <dt>$(B -release)</dt>
		<dd>compile release version
	  $(DT $(B -run) $(I srcfile args...))
		$(DD compile, link, and run the program $(I srcfile) with the
		rest of the
		command line, $(I args...), as the arguments to the program.
		No .o or executable file is left behind.)
	  <dt>$(B -unittest)</dt>
		<dd>compile in unittest code
	  <dt>$(B -v)</dt>
		<dd>verbose
	  <dt>$(B -version=)$(I level)</dt>
		<dd>compile in version code >= $(I level)
	  <dt>$(B -version=)$(I ident)</dt>
		<dd>compile in version code identified by $(I ident)
	  <dt>$(B -w)</dt>
		<dd>enable <a href="warnings.html">warnings</a>
	</dl></dl>

<h2>Linking</h2>

	Linking is done directly by the $(B dmd) compiler after a successful
	compile. To prevent $(B dmd) from running the linker, use the
	$(B -c) switch.
	<p>

	The actual linking is done by running $(B gcc).
	This ensures compatibility with modules compiled with $(B gcc).

<h2>Environment Variables</h2>

	The D compiler dmd uses the following environment variables:

	<dl>

	<dt>$(B CC)
	<dd> $(B dmd) normally runs the linker by looking for $(B gcc)
	along the $(B PATH). To use a specific linker instead, set the
	$(B CC) environment variable to it. For example:

$(CONSOLE
set CC=gcc
)

	<dt>$(B DFLAGS)
	<dd>The value of $(B DFLAGS) is treated as if it were appended to the
	command line to $(B dmd).

	</dl>

<h2>dmd.conf Initialization File</h2>

	$(P $(B dmd) will look for the initialization file $(B dmd.conf) in the
	following sequence of directories:)

	$(OL
	$(LI current working directory)
	$(LI directory specified by the $(B HOME) environment variable)
	$(LI directory $(B dmd) resides in)
	$(LI $(B /etc/))
	)

	$(P If found, environment variable
	settings in the file will override any existing settings.
	This is handy to make $(B dmd) independent of programs with
	conflicting use of environment variables.
	)

	$(P Environment variables follow the $(TT [Environment]) section
	heading, in $(I NAME)=$(I value) pairs.
	The $(I NAME)s are treated as upper case.
	Comments are lines that start with ;.
	For example:
	)

$(SCINI
; dmd.conf file for dmd
; Names enclosed by %% are searched for in the existing environment
; and inserted. The special name %@P% is replaced with the path
; to this file.
[Environment]
DFLAGS="-I%@P%/../src/phobos"
)

<h2>Differences from Win32 version</h2>

	$(UL 
	<li> String literals are read-only. Attempting to write to them
	will cause a segment violation.

	<li> The configuration file is $(TT /etc/dmd.conf)
	)

<hr>
<h1><a name="general">General</a></h1>

<h2><a name="interface_files">D Interface Files</a></h2>

	When an import declaration is processed in a D source file,
	the compiler searches for the D source file corresponding to
	the import, and processes that source file to extract the
	information needed from it. Alternatively, the compiler can
	instead look for a corresponding $(I D interface file).
	A D interface file contains only what an import of the module
	needs, rather than the whole implementation of that module.
	<p>

	The advantages of using a D interface file for imports rather
	than a D source file are:

	$(UL
	$(LI D interface files are often significantly smaller and much
	faster to process than the corresponding D source file.)
	$(LI They can be used to hide the source code, for example,
	one can ship an object code library along with D interface files
	rather than the complete source code.)
	)

	D interface files can be created by the compiler from a
	D source file by using the $(B -H) switch to the compiler.
	D interface files have the $(B .di) file extension.
	When the compiler resolves an import declaration, it first looks
	for a $(B .di) D interface file, then it looks for a D source
	file.
	<p>

	D interface files bear some analogous similarities to C++
	header files. But they are not required in the way that C++
	header files are, and they are not part of the D language.
	They are a feature of the compiler, and serve only as an optimization
	of the build process.
)

Macros:
	TITLE=D Programming Language - DMD Compiler
	WIKI=DCompiler

